void mouse(int button, int state, int x, int y)
{
  QMouseEvent e(x,y);
  if (state == GLUT_DOWN)
  {
    switch (button)
    {
    case GLUT_LEFT_BUTTON:
      camera.frame()->startAction(ROTATE);break;
    case GLUT_MIDDLE_BUTTON:
      camera.frame()->startAction(ZOOM);break;
    case GLUT_RIGHT_BUTTON:
      camera.frame()->startAction(TRANSLATE);break;
    }      
    camera.frame()->mousePressEvent(&e,&camera);
  }
  else
  {
    camera.frame()->mouseReleaseEvent(&e,&camera);
  }
  glutPostRedisplay();
}

void motion(int x, int y)
{
  QMouseEvent e(x,y);
  if (camera.isManipulated())
  {
    camera.frame()->mouseMoveEvent(&e, &camera);
  }
  glutPostRedisplay();
}

void reshape(int w, int h)
{
  glViewport( 0, 0, w, h );
  camera.setWindowWidthAndHeight(w,h);
  glutPostRedisplay();
}
void init(void)
{
#ifdef GL_RESCALE_NORMAL
  glEnable(GL_RESCALE_NORMAL);
#endif 

  glEnable(GL_DEPTH_TEST);
  glEnable(GL_LIGHTING);
  glEnable(GL_LIGHT0);
  glEnable(GL_COLOR_MATERIAL);
  glColorMaterial(GL_FRONT_AND_BACK,GL_AMBIENT_AND_DIFFUSE);

  if (fileName != 0)
  {
    scene.load(fileName, false);

    Vec min(scene.getBBoxMin().x, scene.getBBoxMin().y, scene.getBBoxMin().z);
    Vec max(scene.getBBoxMax().x, scene.getBBoxMax().y, scene.getBBoxMax().z);
  
    camera.setSceneBoundingBox(min, max);
  }
  camera.showEntireScene();
  glColor3f(1.0f,1.0f,1.0f);
}
